%global _default_patch_fuzz 2

%global selinux_module 1
%global selinux_types %(%{__awk} '/^#[[:space:]]*SELINUXTYPE=/,/^[^#]/ { if ($3 == "-") printf "%s ", $2 }' /etc/selinux/config 2>/dev/null)
%global selinux_variants %([ -z "%{selinux_types}" ] && echo mls strict targeted || echo %{selinux_types})
%global selinux_buildreqs checkpolicy, selinux-policy-devel, hardlink

Name:       onak
Version:    0.4.2
Release:    1%{?dist}
Summary:    onak - OpenPGP keyserver
Group:      Applications/Internet
License:    GPLv2+
URL:        http://www.earth.li/projectpurple/progs/onak.html
Source0:    http://www.earth.li/projectpurple/files/%{name}-%{version}.tar.xz
Source1:    onak.sysconfig
Source2:    onak.init
Source10:   onak.te
Source11:   onak.fc
Patch0:     onak-Makefile.diff
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  coreutils glibc-devel gcc make db4-devel libcurl-devel
Requires(pre): shadow-utils
Requires(post): chkconfig
Requires(post): db4-utils
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

%description

onak is an OpenPGP keyserver. When I first started thinking about writing it there was no Free keyserver that could handle multiple subkey bindings. Now there are at least three I believe (CryptNet, onak and SKS). Also I wanted a keyserver that was integrated with my key pathfinder ( http://the.earth.li/~noodles/pathfind.html). onak does both of these. While there are many things it doesn't do at present that are on my todo list development is progressing. The pathfinder component works happily, it's possible to setup bidirectional key syncing with pksd via email and there are a variety of database backends available including plain files, PostgreSQL and Berkeley DB4.

%global selinux_policyver %(%{__sed} -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp || echo 0.0.0)
%global selinux_policynum %(echo %{selinux_policyver} | %{__awk} -F. '{ printf "%d%02d%02d", $1, $2, $3 }')
%package selinux
Summary:          SELinux policy module supporting to query onak from apache
Group:            System Environment/Base
BuildRequires:    %{selinux_buildreqs}
# selinux-policy is required for directory ownership of %{_datadir}/selinux/*
# Modules built against one version of a policy may not work with older policy
# versions, as noted on fedora-selinux-list:
# http://www.redhat.com/archives/fedora-selinux-list/2006-May/msg00102.html
# Hence the versioned dependency. The versioning will hopefully be replaced by
# an ABI version requirement or something similar in the future
Requires:         selinux-policy >= %{selinux_policyver}
Requires:         %{name} = %{version}-%{release}
Requires(post):   /usr/sbin/semodule, /sbin/restorecon
Requires(postun): /usr/sbin/semodule, /sbin/restorecon

%description selinux
SELinux policy module supporting to query onak from apache

%prep
%setup -q
%patch0 -p1

%{__cp} -p %{SOURCE10} onak.te
%{__cp} -p %{SOURCE11} onak.fc


%build
%configure --prefix=/usr 
make %{?_smp_mflags}

for selinuxvariant in %{selinux_variants}
do
        %{__make} NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
        %{__mv} onak.pp onak.pp.${selinuxvariant}
        %{__make} NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/onak
install -Dp -m0644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/onak
install -Dp -m0755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_initrddir}/onak
install -Dp -m0644 onak.conf ${RPM_BUILD_ROOT}%{_sysconfdir}/onak.conf

for selinuxvariant in %{selinux_variants}
do
        %{__install} -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
        %{__install} -p -m 644 onak.pp.${selinuxvariant} \
                %{buildroot}%{_datadir}/selinux/${selinuxvariant}/onak.pp
done
# Hardlink identical policy module packages together
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux


%clean
rm -rf %{buildroot}

%pre
getent group apache >/dev/null || groupadd -r -g 48 apache
getent passwd apache >/dev/null || \
useradd -r -g apache -u 48 -d /var/www -s /sbin/nologin \
-c "Apache" apache
exit 0

%post selinux
# Install SELinux policy modules
for selinuxvariant in %{selinux_variants}
do
        /usr/sbin/semodule -s ${selinuxvariant} -i \
                %{_datadir}/selinux/${selinuxvariant}/onak.pp &> /dev/null || :
done
chcon --type=onak_socket_t /var/lib/onak/keyd.sock
restorecon -R /var/log/onak.log
restorecon -R /usr/lib64/cgi-bin/pks/

%postun selinux
# Clean up after package removal
if [ $1 -eq 0 ]; then
        # Remove SELinux policy modules
        for selinuxvariant in %{selinux_variants}; do
                /usr/sbin/semodule -s ${selinuxvariant} -r onak &> /dev/null || :
        done
fi
exit 0


%files
%defattr(-,root,root,-)
%doc apache2 BUGS CGI HISTORY LICENSE PERFORMANCE README THANKS TODO 
%attr(0755,root,root) %{_bindir}/onak
%attr(0755,root,root) %{_bindir}/splitkeys
%attr(0755,root,root) %{_bindir}/keydctl
%attr(0755,root,root) %{_sbindir}/keyd
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/onak
%attr(0644,root,root) %{_mandir}/man1/onak*
%attr(0644,root,root) %{_mandir}/man8/onak*
%attr(0644,root,root) %{_mandir}/man8/keyd*
%attr(0644,root,root) %{_mandir}/man1/splitkeys*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/onak.conf
%attr(0755,root,root) %{_initrddir}/onak
%attr(0755,apache,apache) %{_localstatedir}/lib/onak
%attr(0755,root,root) %{_libdir}/onak/onak-mail.pl
%attr(0644,root,root) %{_libdir}/onak/backends/*.so
%attr(0755,root,root) %{_libdir}/cgi-bin

%files selinux
%defattr(-,root,root,-)
%{_datadir}/selinux/*/onak.pp

%changelog

* Sun Aug 26 2012 mh <mh+rpms@immerda.ch> - 0.4.1-1
- Initial release
